# POST /transaction/refund/{{payment_id}} — Record Refund

> Product: **Pabbly Subscription Billing** (v1)
> Base URL: `https://payments.pabbly.com/api/v1`
> Auth: Basic via `Authorization` header
> Canonical: `/subscription-billing/payment-transaction/record-refund`

This API can be used to Record the Refunds. The API will be fired with a POST request along with the transaction ID in the API link. In response, you will get the successful message of Payment Refunded.

**Path parameters:**

| Name | Type | Required | Description |
|------|------|----------|-------------|
| payment_id | string | Yes |  |

**Body parameters:**

| Name | Type | Required | Description |
|------|------|----------|-------------|
| amount | integer | No |  |
| refund_type | string | No |  |
| description | string | No |  |

**Example request body:**

```json
{
	"amount":90,
	"refund_type":"record_refund",
	"description":"Payment record"
}
```

**Response (200)** — Record Refund:

```json
{
    "status": "success",
    "message": "Payment refunded"
}
```

**Code examples:**

_cURL_

```curl
curl -X POST https://payments.pabbly.com/api/v1/transaction/refund/{{payment_id}} \
  -u {{YOUR_API_KEY}}:{{YOUR_SECRET_KEY}} \
  -H "Content-Type: application/json" \
  -d '{
    "amount": 90,
    "refund_type": "record_refund",
    "description": "Payment record"
  }'
```

_Ruby_

```ruby
require 'net/http'
require 'json'

uri = URI('https://payments.pabbly.com/api/v1/transaction/refund/{{payment_id}}')
request = Net::HTTP::Post.new(uri)
request.basic_auth '{{YOUR_API_KEY}}', '{{YOUR_SECRET_KEY}}'
request['Content-Type'] = 'application/json'
request.body = "{\"amount\":90,\"refund_type\":\"record_refund\",\"description\":\"Payment record\"}"

response = Net::HTTP.start(uri.hostname, uri.port, use_ssl: uri.scheme == 'https') do |http|
  http.request(request)
end

data = JSON.parse(response.body)
```

_Python_

```python
import requests
from requests.auth import HTTPBasicAuth

response = requests.post(
    'https://payments.pabbly.com/api/v1/transaction/refund/{{payment_id}}',
    auth=HTTPBasicAuth('{{YOUR_API_KEY}}', '{{YOUR_SECRET_KEY}}'),
    json={
    'amount': 90,
    'refund_type': 'record_refund',
    'description': 'Payment record'
},
)

data = response.json()
```

_PHP_

```php
<?php
$ch = curl_init('https://payments.pabbly.com/api/v1/transaction/refund/{{payment_id}}');
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'POST');
curl_setopt($ch, CURLOPT_USERPWD, '{{YOUR_API_KEY}}:{{YOUR_SECRET_KEY}}');
curl_setopt($ch, CURLOPT_HTTPHEADER, ['Content-Type: application/json']);
curl_setopt($ch, CURLOPT_POSTFIELDS, '{"amount":90,"refund_type":"record_refund","description":"Payment record"}');

$response = curl_exec($ch);
curl_close($ch);
$data = json_decode($response, true);
```

_Java_

```java
import java.net.URI;
import java.net.http.HttpClient;
import java.net.http.HttpRequest;
import java.net.http.HttpResponse;
import java.util.Base64;

String credentials = Base64.getEncoder().encodeToString("{{YOUR_API_KEY}}:{{YOUR_SECRET_KEY}}".getBytes());

HttpClient client = HttpClient.newHttpClient();
HttpRequest.Builder builder = HttpRequest.newBuilder()
    .uri(URI.create("https://payments.pabbly.com/api/v1/transaction/refund/{{payment_id}}"))
    .header("Authorization", "Basic " + credentials)
    .header("Content-Type", "application/json")
    .method("POST", HttpRequest.BodyPublishers.ofString("{\"amount\":90,\"refund_type\":\"record_refund\",\"description\":\"Payment record\"}"));

HttpRequest request = builder.build();
HttpResponse<String> response = client.send(request, HttpResponse.BodyHandlers.ofString());
System.out.println(response.body());
```

_Node.js_

```node
const credentials = Buffer.from('{{YOUR_API_KEY}}:{{YOUR_SECRET_KEY}}').toString('base64');

const response = await fetch('https://payments.pabbly.com/api/v1/transaction/refund/{{payment_id}}', {
  method: 'POST',
  headers: {
    'Authorization': `Basic ${credentials}`,
    'Content-Type': 'application/json',
  },
  body: JSON.stringify({
    "amount": 90,
    "refund_type": "record_refund",
    "description": "Payment record"
  }),
});

const data = await response.json();
```

_Go_

```go
package main

import (
    "fmt"
    "io"
    "net/http"
    "strings"
)

func main() {
    payload := strings.NewReader("{\"amount\":90,\"refund_type\":\"record_refund\",\"description\":\"Payment record\"}")
    req, _ := http.NewRequest("POST", "https://payments.pabbly.com/api/v1/transaction/refund/{{payment_id}}", payload)
    req.Header.Set("Content-Type", "application/json")
    req.SetBasicAuth("{{YOUR_API_KEY}}", "{{YOUR_SECRET_KEY}}")

    res, _ := http.DefaultClient.Do(req)
    defer res.Body.Close()
    body, _ := io.ReadAll(res.Body)
    fmt.Println(string(body))
}
```

_.NET_

```dotnet
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;

var credentials = Convert.ToBase64String(Encoding.ASCII.GetBytes("{{YOUR_API_KEY}}:{{YOUR_SECRET_KEY}}"));

var client = new HttpClient();
var request = new HttpRequestMessage(HttpMethod.Post, "https://payments.pabbly.com/api/v1/transaction/refund/{{payment_id}}");
request.Headers.TryAddWithoutValidation("Authorization", $"Basic {credentials}");
request.Content = new StringContent("{\"amount\":90,\"refund_type\":\"record_refund\",\"description\":\"Payment record\"}");
request.Content.Headers.ContentType = new MediaTypeHeaderValue("application/json");

var response = await client.SendAsync(request);
var data = await response.Content.ReadAsStringAsync();
Console.WriteLine(data);
```

---

**Other endpoints in Payment/Transaction:**

- [GET /transactions/{{customer_id}} — List All Transactions By Customer Id](/subscription-billing/payment-transaction/list-all-transactions-by-customer-id)
- [GET /refund/{{customer_id}} — List All Refund By Customer Id](/subscription-billing/payment-transaction/list-all-refund-by-customer-id)
- [DELETE /transaction/{{transaction_id}} — Delete Transaction](/subscription-billing/payment-transaction/delete-transaction)
- [POST /transaction/refund/{{payment_id}} — Payment Refund](/subscription-billing/payment-transaction/payment-refund)

